//  MIPC

#property copyright "mandorr@gmail.com"
#import "kernel32.dll"
   void GetLocalTime(int& TimeArray[]);
#import

int TotalTicks=100;
int start_init=0;
int i, nBid, nBid_prev;
int TotalUp20, TotalDn20, SumUp20, SumDn20, AverageUp20, AverageDn20;
int nTrend;
int nYear,nMonth,nDayOfWeek,nDay,nHour,nMinute,nSecond,nMillisecond;
int nHour_prev;
int time, time_prev;
int price[];
int delta[];

void init() {
   start_init=0;
   nBid_prev=0;
   Comment ("");
}

void deinit() {
   Comment ("");
}

void start() {
   nBid=MathRound(Bid/Point);
   if (start_init==0) {
      start_init=1;
      GetTime();
      time=60000*nMinute+1000*nSecond+nMillisecond;
      time_prev=time;
      nHour_prev=nHour;
      ArrayResize(price,TotalTicks+1);
      ArrayResize(delta,TotalTicks+1);
      for (i=0; i<=TotalTicks; i++) {
         price[i]=nBid;
         delta[i]=0;
      }
      return;
   }
   if (nBid==nBid_prev) return;
   nBid_prev=nBid;
   for (i=TotalTicks-1; i>=0; i--) {
      price[i+1]=price[i];
      delta[i+1]=delta[i];
   }
   price[0]=nBid;
   GetTime();
   time=60000*nMinute+1000*nSecond+nMillisecond;
   delta[0]=time-time_prev;
   if (nHour!=nHour_prev) delta[0]=delta[0]+3600000;
   nHour_prev=nHour;
   time_prev=time;

   TotalUp20=0;
   TotalDn20=0;
   SumUp20=0;
   SumDn20=0;
   AverageUp20=0;
   AverageDn20=0;
   for (i=0; i<20; i++) {
      if (price[i]>price[i+1]) { TotalUp20++; SumUp20+=delta[i];}
      if (price[i]<price[i+1]) { TotalDn20++; SumDn20+=delta[i];}
   }
   if (TotalUp20>0) AverageUp20=SumUp20/TotalUp20;
   if (TotalDn20>0) AverageDn20=SumDn20/TotalDn20;

   string sTrend="";
   nTrend=0;
   if (TotalUp20+TotalDn20>=20) {
      if (TotalUp20>TotalDn20 && AverageUp20<=(AverageDn20-2000)) nTrend++;
      if (TotalDn20>TotalUp20 && AverageDn20<=(AverageUp20-2000)) nTrend--;
   }
   if (nTrend>0) sTrend="";
   if (nTrend<0) sTrend="";

   string msg=" 20 , ms:";
   for (i=0; i<20; i++) {
      if (price[i]>price[i+1]) msg=msg+" +"+delta[i];
      if (price[i]<price[i+1]) msg=msg+" -"+delta[i];
   }
   
   Comment (
      msg,"\n",
      "  20   : ",TotalUp20,"      : ",AverageUp20,"  ms\n",
      "  20    : ",TotalDn20,"      : ",AverageDn20,"  ms\n",
      " : ",sTrend
   );
}

void GetTime() {
   int TimeArray[4];
   GetLocalTime(TimeArray);
   nYear=TimeArray[0]&0x0000FFFF;
   nMonth=TimeArray[0]>>16;
   nDayOfWeek=TimeArray[1]&0x0000FFFF;
   nDay=TimeArray[1]>>16;
   nHour=TimeArray[2]&0x0000FFFF;
   nMinute=TimeArray[2]>>16;
   nSecond=TimeArray[3]&0x0000FFFF;
   nMillisecond=TimeArray[3]>>16;
}

// End